%{
#include <stdlib.h>
#include <string.h>
entry *install_id(char *);
%}

id [A-Za-z][A-Za-z0-9]*
num [0-9]+
ws [ \t\n]+

%%

{ws}		/*doing nothing*/
"begin"		return MYBEGIN;
"end"		return END;
"input"		return INPUT;
"output"	return OUTPUT;
"while"		return WHILE;
"do"		return DO;
"function"	return FUNCTION;
"main"		return MAIN;
"var"		return VAR;
">="		return GREATER_OR_EQUAL;
"<="		return LESS_OR_EQUAL;
"!="		return NOT_EQUAL;
">"			return GREATER;
"<"			return LESS;
"="			return ('=');
"+"			return ('+');
"-"			return ('-');
"*"			return ('*');
"("			return ('(');
")"			return (')');
";"			return (';');
","			return (',');
{id}		{				
				temp_n=tableLen;
				yylval.id_type=install_id(yytext);
				return ID;
            }
{num}		{
				yylval.num_type=atoi(yytext); 
				return NUM;
            }
.			return(yytext[0]);
	
%%

entry *install_id(char *symbol_name)
	{
		entry *ptr=table;
		for(i=0;i<=tableLen;i++)
			{
				if(strcmp(symbol_name, table[i].name)==0)
				{
					ptr=&table[i];
					return ptr;
				}
			}
		tableLen++;
		strcpy(table[tableLen].name,symbol_name);
		ptr=&table[tableLen];
		return ptr;
	}
